import { NodePropSource } from 'lezer-tree';
import { LanguageSupport, LanguageDescription } from '@codemirror/language';
import { Tag } from "@codemirror/highlight";
import type { Extension } from '@codemirror/state';
import type { IMonarchLanguage } from './monarch/monarchCommon';
export interface MonarchLanguageDefinition {
    name: string;
    lexer: IMonarchLanguage;
    configure?: MonarchConfigure;
    alias?: string[];
    ext?: string[];
    languageData?: {
        [name: string]: any;
    };
    extraExtensions?: Extension[];
}
export interface MonarchLanguageData {
    load(): LanguageSupport;
    tags: {
        [name: string]: Tag;
    };
    description: LanguageDescription;
    props: () => any[];
}
export declare function createMonarchLanguage(opts: MonarchLanguageDefinition): MonarchLanguageData;
export interface MonarchConfigure {
    props?: NodePropSource[];
}
